> For the complete documentation index, see [llms.txt](https://docs.learncard.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.learncard.com/sdks/learncloud-storage-api/architecture.md).

# Architecture

## Deployment Architecture <a href="#deployment-architecture" id="deployment-architecture"></a>

LearnCloud Storage is deployed as a serverless application on AWS.

```mermaid
graph TB
    subgraph "AWS Infrastructure"
        api["API Gateway"]
        lambda["Lambda Functions"]
        sg["Security Groups"]
        vpc["Virtual Private Cloud"]

        subgraph "Storage"
            mongodb["MongoDB"]
            redis["Redis Cache"]
        end
    end

    client["Client Applications"] -->|"HTTP/HTTPS"| api
    api -->|"Invokes"| lambda
    lambda -->|"Query/Update"| mongodb
    lambda -->|"Cache"| redis

    lambda -->|"Handle"| xapi["xAPI Statements"]
    lambda -->|"Authenticate"| oidc["OIDC Flows"]
```

## API Endpoints

The LearnCloud Storage API exposes the following endpoints:

| Endpoint                            | Description                 | Handler            |
| ----------------------------------- | --------------------------- | ------------------ |
| `/trpc/*`                           | tRPC API endpoints          | `trpcHandler`      |
| `/api/*`                            | OpenAPI REST endpoints      | `openApiHandler`   |
| `/users/*`                          | DID Web identity resolution | `didWebHandler`    |
| `/xapi/*`                           | xAPI statement handling     | `xApiHandler`      |
| `/oidc/*`                           | OIDC authentication         | `oidcHandler`      |
| `/.well-known/openid-configuration` | OIDC configuration          | `oidcHandler`      |
| `/docs`                             | Swagger UI documentation    | `swaggerUiHandler` |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.learncard.com/sdks/learncloud-storage-api/architecture.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
